﻿/*
    Program demonstrujici pouziti prikazu lock.
*/

using System;
using System.Threading;

namespace Account
{
    class Account
    {
        private object thisLock = new object();
        private int balance;

        Random r = new Random();

        public Account(int initial)
        {
            balance = initial;
        }

        public int Withdraw(int amount)
        {

            // Tato podminka nebude nikdy splnena (pokud je 
            // pouzity prikaz lock)
            if (balance < 0)
                throw new ArithmeticException("Záporná bilance");

            lock (thisLock)
            {
                if (balance >= amount)
                {
                    Console.Write(balance.ToString().PadLeft(12));
                    Console.Write(amount.ToString().PadLeft(19));
                    balance -= amount;
                    Console.WriteLine(balance.ToString().PadLeft(13));
                    return amount;
                }
                else
                {
                    return 0;
                }
            }
        }

        public void DoTransactions()
        {
            for (int i = 0; i < 100; i++)
                Withdraw(r.Next(1, 500));
        }
    }

    class Program
    {
        private const int numThreads = 5;

        static void Main()
        {
            Thread[] threads = new Thread[numThreads];
            Account account = new Account(1000);

            Console.WriteLine("Před výběrem    Vybíraná částka    Po výběru");
            Console.WriteLine("--------------------------------------------");

            for (int i = 0; i < numThreads; i++)
            {
                threads[i] = new Thread(account.DoTransactions);
            }

            for (int i = 0; i < numThreads; i++)
                threads[i].Start();
        }
    }
}
