﻿/*
    Program demonstrující předávání řízení při použítí klíčových
    slov await a async.
*/

using System;
using System.Threading.Tasks;
using System.Threading;

namespace AsyncAwait
{
    class Program
    {
        public static Task<int> NonBlockingOper()
        {
            return Task.Run(() =>
            {
                Console.WriteLine("Uvnitř NonBlockingOper - Thread ID: "
                    + Thread.CurrentThread.ManagedThreadId);
                Thread.Sleep(1000);
                return 10;
            }
            );
        }

        async static public Task<int> DoWorkAsync()
        {
            Console.WriteLine("Uvnitř DoWorkAsync 1 - "
                + "Thread ID: " + Thread.CurrentThread.ManagedThreadId);

            Task<int> result = NonBlockingOper();

            for (int i = 1; i <= 100; i++)
                Console.WriteLine("Uvnitř DoWorkAsync 2 - "
                    + i + " Thread ID: " + Thread.CurrentThread.ManagedThreadId);

            int retValue = await result;

            Console.WriteLine("Očekávaný výsledek: " + retValue +
                " - Thread ID: " + Thread.CurrentThread.ManagedThreadId);

            return retValue;
        }

        static void Main(string[] args)
        {
            Task<int> result = DoWorkAsync();

            for (int i = 1; i <= 100; i++)
                Console.WriteLine("Uvnitř Main - " + i + " Thread ID: "
                    + Thread.CurrentThread.ManagedThreadId);

            Console.WriteLine("Výsledná hodnota: " + result.Result);
        }
    }
}


