﻿/*
    Program ukazujici pouziti tridy Task.
*/

using System;
using System.Threading.Tasks;

namespace TaskDemo
{
    class Program
    {
        private const int numThreads = 10;
        private const int numValues = 10;

        private static int[,] values;
        private static int[] results;

        public static void GenerateValues()
        {
            Random rand = new Random();

            for (int i = 0; i < numThreads; i++)
                for (int j = 0; j < numValues; j++)
                    values[i, j] = rand.Next(10);
        }

        public static void Sum(object n)
        {
            int row = (int)n;

            results[row] = 0;
            for (int i = 0; i < numValues; i++)
                results[row] += values[row, i];

            Console.WriteLine("Dokončen součet řádku {0}", row);
        }

        public static void WriteResults()
        {
            for (int i = 0; i < numThreads; i++)
            {
                Console.Write("{0,2}. řádek:", i + 1);

                for (int j = 0; j < numValues; j++)
                    Console.Write("{0,3}", values[i, j]);

                Console.WriteLine("  má součet prvků {0,3}", results[i]);
            }
        }

        static void Main(string[] args)
        {
            values = new int[numThreads, numValues];
            results = new int[numThreads];

            GenerateValues();

            Task[] tasks = new Task[numThreads];

            for (int i = 0; i < numThreads; i++)
            {
                tasks[i] = new Task(Sum, i);
                tasks[i].Start();
            }
            Task.WaitAll(tasks);

            WriteResults();
        }
    }
}


