﻿/*
    Program ukazujici pouziti tridy ThreadPool 2.
*/

using System;
using System.Threading;

namespace ThreadPool2
{
    class Program
    {
        const int numThreads = 10;
        const int numValues = 10;

        private static CountdownEvent cEvent;
        private static int[,] values;
        private static int[] results;

        public static void GenerateValues()
        {
            Random rand = new Random();

            for (int i = 0; i < numThreads; i++)
                for (int j = 0; j < numValues; j++)
                    values[i, j] = rand.Next(10);
        }

        public static void Sum(object n)
        {
            int row = (int)n;

            results[row] = 0;
            for (int i = 0; i < numValues; i++)
                results[row] += values[row, i];

            Console.WriteLine("Dokočen součet řádku {0}", row);
            cEvent.Signal();
        }

        public static void WriteResults()
        {
            for (int i = 0; i < numThreads; i++)
            {
                Console.Write("{0,2}. řádek:", i + 1);

                for (int j = 0; j < numValues; j++)
                    Console.Write("{0,3}", values[i, j]);

                Console.WriteLine("  má součet prvků {0,3}", results[i]);
            }
        }

        static void Main(string[] args)
        {
            values = new int[numThreads, numValues];
            results = new int[numThreads];

            GenerateValues();

            cEvent = new CountdownEvent(numThreads);

            for (int i = 0; i < numThreads; i++)
                ThreadPool.QueueUserWorkItem(Sum, i);
            cEvent.Wait();

            WriteResults();
        }
    }
}

